Subject: bug#35010: Many CPAN download URLs are no longer available

From: Ludovic Courtès <[email-masked]>
Date: Fri, 29 Mar 2019 16:34:02 +0100

Mark H Weaver <[email-masked]> skribis:

> Ludovic Courtès <[email-masked]> writes:
>
>> The good news is that the (guix upstream) framework gets to see the
>> correct URL:
>>
>> scheme@(guile-user)> (package-latest-release perl-uri (force %updaters))
>> $6 = #<<upstream-source> package: "perl-uri" version: "1.76" urls: ("mirror://cpan/authors/id/O/OA/OALDERS/URI-1.76.tar.gz") signature-urls: #f input-changes: #<procedure 7fced1c44ca0 at guix/import/cpan.scm:308:7 (x)>>
>>
>> So with a bit of work we could change ‘package-update’ to automatically
>> update the URL.
>>
>> (Time passes…)
>>
>> Commit 42314ffa072f31cc1cb44df38b1f8fcca19d9d3c should fix this.
>
> Nice!  I haven't looked closely, but does this somehow update the code
> that computes source URLs using 'string-append'?  If so, that's
> impressive :)

Well, yes and no.  :-)

It looks like that’s what it does, but in practice it simply does a
string substitution on the ‘dirname’ of the URI, which probably works in
most cases (it definitely works for CPAN packages.)

> In other news, here's another batch of bad source URLs that Hydra
> recently failed to fetch:
>
>   mirror://savannah/starfighter/1.7/project-starfighter-1.7-src.tar.gz
>   mirror://cpan/authors/id/P/PI/PIJLL/DateTime-Calendar-Julian-0.100.tar.gz
>   mirror://cpan/authors/id/A/AD/ADAMK/Object-Signature-1.08.tar.gz
>   mirror://cpan/authors/id/J/JH/JHI/Time-HiRes-1.9760.tar.gz
>   mirror://cpan/authors/id/F/FR/FREW/Class-C3-Componentised-1.001002.tar.gz
>   mirror://cpan/authors/id/R/RG/RGARCIA/base-2.23.tar.gz

Thanks!

Ludo’.